## cgreen 1.6.3

=== CMakeLists.txt ===
# Required cmake version
cmake_minimum_required(VERSION 2.8.12)

project(cgreen)

if (NOT(CMAKE_MAJOR_VERSION LESS 3) AND APPLE)
  if(POLICY CMP0042)
    cmake_policy(SET CMP0042 NEW) # CMake 3.0 to use @rpath on MacOSX libraries
  endif()
endif()

find_package (Threads)

set(CGREEN_WITH_XML ON CACHE BOOL
    "Add a simple XML report generator without external dependencies")
set(CGREEN_WITH_LIBXML2 ON CACHE BOOL
    "Add an XML report generator which uses libxml2 for output formatting")

if (CGREEN_WITH_LIBXML2)
  find_package (LibXml2)
  if (NOT LibXml2_FOUND)
    set(CGREEN_WITH_LIBXML2 OFF)
  endif (NOT LibXml2_FOUND)
endif (CGREEN_WITH_LIBXML2)

enable_testing()

# global needed variables
set(APPLICATION_NAME ${PROJECT_NAME})

# VERSION:
# NOTE: If you change version here, also change in
# include/cgreen/cgreen.h unless you write some code that
# automatically updates that...
set(APPLICATION_VERSION_MAJOR "1")
set(APPLICATION_VERSION_MINOR "6")
set(APPLICATION_VERSION_PATCH "3")

set(APPLICATION_VERSION ${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}.${APPLICATION_VERSION_PATCH}${APPLICATION_VERSION_STATUS})
add_definitions(-DVERSION="${APPLICATION_VERSION}")

set(LIBRARY_VERSION ${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}.${APPLICATION_VERSION_PATCH})
set(LIBRARY_SOVERSION ${APPLICATION_VERSION_MAJOR})


# INSTALL:
include(GNUInstallDirs)

if(MSVC)
  # these have sensible defaults on other platforms
  set(CMAKE_INSTALL_BINDIR ".")
  set(CMAKE_INSTALL_LIBDIR ".")
endif(MSVC)

# If OSX and using Homebrew use its install prefix
find_program(BREW brew)
if (BREW)
  execute_process(COMMAND brew --prefix OUTPUT_VARIABLE CMAKE_INSTALL_PREFIX OUTPUT_STRIP_TRAILING_WHITESPACE)
endif()

# COMPLETION:
set(BASHCOMPLETION_STATUS "Unavailable")
find_package(bash-completion QUIET)
if(BASH_COMPLETION_FOUND OR UNIX)
  set(BASHCOMPLETION_STATUS "Available")
  install(FILES tools/cgreen_completion.bash DESTINATION "${CMAKE_INSTALL_DATADIR}/bash-completion/completions" RENAME "cgreen-runner")
  install(FILES tools/cgreen_completion.bash DESTINATION "${CMAKE_INSTALL_DATADIR}/bash-completion/completions" RENAME  "cgreen-debug")
endif()

# CMAKE MODULES:
# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
set(CMAKE_MODULE_PATH
  ${PROJECT_SOURCE_DIR}/cmake/Modules
)

# add definitions
include(DefineCMakeDefaults)
include(DefineCompilerFlags)
include(DefineOptions.cmake)
include(DefineCPackConfig)

# add macros
include(MacroAddPlugin)
include(MacroCopyFile)

# GIT REVISION:
# Generate gitrevision.h if Git is available and the .git directory is found.
find_program(GIT_EXECUTABLE git DOC "Git version control")
mark_as_advanced(GIT_EXECUTABLE)

# Find path to .git/logs/HEAD so that the gitrevision.h generation will only
# happen on new commits. This is done from $PROJECT_SOURCE_DIR because git rev-parse
# doesn't always return an absolute path so need to use get_filename_component()
# to get a cross-platform `readlink -f $(git rev-parse --git-path logs/HEAD)`
execute_process(
  COMMAND ${GIT_EXECUTABLE} rev-parse --git-path logs/HEAD
  WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
  OUTPUT_VARIABLE GITDIR
  OUTPUT_STRIP_TRAILING_WHITESPACE
  )
if (GITDIR)
  get_filename_component(GITDIR "${GITDIR}" ABSOLUTE)
endif()

# config.h checks
include(ConfigureChecks.cmake)
configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

# check subdirectories
add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(include)

# Dependency on our own library so we can use CGREEN_LIBRARY in all subdirectories
if (CGREEN_WITH_STATIC_LIBRARY)
  set(CGREEN_LIBRARY ${CGREEN_STATIC_LIBRARY})
else ()
  set(CGREEN_LIBRARY ${CGREEN_SHARED_LIBRARY})
endif()

if (CGREEN_WITH_UNIT_TESTS)
  include(MacroAddUnitTest)
  include(MacroAddTest)
  include(MacroAddValgrindTest)
  add_subdirectory(tests)
  if (UNIX OR MSYS)
    # reflective runner only supported on UNIX/binutils platforms
    add_subdirectory(tools)
  endif(UNIX OR MSYS)
endif (CGREEN_WITH_UNIT_TESTS)

# add custom 'check' target to run tests with output-on-failure
if (CMAKE_CONFIGURATION_TYPES)
    add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND}
        --force-new-ctest-process --output-on-failure
        --build-config "$<CONFIGURATION>")
else()
    add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND}
        --force-new-ctest-process --output-on-failure)
endif()

IF(CGREEN_INTERNAL_WITH_GCOV)
  IF(CMAKE_C_COMPILER_ID STREQUAL GNU)
    include(CodeCoverage)
    add_custom_target(coverage
        COMMAND ${LCOV_PATH} --directory . --capture --output-file coverage.info
        COMMAND ${LCOV_PATH} --remove coverage.info '/usr/*' -o coverage.info
        COMMAND ${GENHTML_PATH} -o coverage coverage.info
    )
  ENDIF()
ELSE()
  add_custom_target(coverage
      COMMAND echo "WARNING: Configure CGREEN_INTERNAL_WITH_GCOV to get coverage")
ENDIF()


#### Begin cgreen package configuration steps. ####

# After install other CMake projects can
# use find_package( cgreen )

set( CONFIG_INSTALL_DIR
        "${CMAKE_INSTALL_LIBDIR}/cmake/${APPLICATION_NAME}" )

set( PROJECT_CONFIG_IN
        "${CMAKE_CURRENT_SOURCE_DIR}/cgreen-config.cmake.in" )

set( VERSION_CONFIG_IN
        "${CMAKE_CURRENT_SOURCE_DIR}/cgreen-config-version.cmake.in" )

set( PROJECT_CONFIG
        "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/cgreen-config.cmake" )

set( VERSION_CONFIG
        "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/cgreen-config-version.cmake" )

configure_file( ${PROJECT_CONFIG_IN}
        "${PROJECT_CONFIG}" @ONLY )

configure_file( ${VERSION_CONFIG_IN}
        "${VERSION_CONFIG}" @ONLY )

install(FILES
        "${PROJECT_CONFIG}" "${VERSION_CONFIG}"
        DESTINATION
        "${CONFIG_INSTALL_DIR}" )

#### End cgreen package configuration steps. ####

=== Makefile ===
# This Makefile ensures that the build is made out of source in a
# subdirectory called 'build' If it doesn't exist, it is created.
#
# This Makefile also contains delegation of the most common make commands
#
# If you have cmake installed you should be able to do:
#
#	make
#	make test
#	make install
#	make package
#
# That should build Cgreen in the build directory, run some tests,
# install it locally and generate a distributable package.

ifndef VERBOSE
MAKEFLAGS += --no-print-directory
endif

.PHONY:all
all: build-it

.PHONY:debug
debug:
	cmake -DCMAKE_BUILD_TYPE:string=Debug -S . -B build
	$(MAKE) -C build

.PHONY:test
test: build-it
	cd build; ctest

.PHONY:clean
clean: build/Makefile
	$(MAKE) -C build clean

.PHONY:package
package: build/Makefile
	$(MAKE) -C build package

.PHONY:install
install: build
ifeq ($(OS),Msys)
	# Thanks to https://stackoverflow.com/a/46027426/204658
	$(MAKE) -C build install DESTDIR=/
else
	$(MAKE) -C build install
endif

# This is kind of a hack to get a quicker and clearer feedback when
# developing Cgreen by allowing 'make unit'. Must be updated when new
# test libraries or output comparisons are added.

# Find out if 'uname -o' works, if it does - use it, otherwise use 'uname -s'
UNAMEOEXISTS=$(shell uname -o &>/dev/null; echo $$?)
ifeq ($(UNAMEOEXISTS),0)
  OS=$(shell uname -o)
else
  OS=$(shell uname -s)
endif

# Set prefix and suffix for shared libraries depending on platform
ifeq ($(OS),Darwin)
	LDPATH=DYLD_LIBRARY_PATH=$(PWD)/build/src
	PREFIX=lib
	SUFFIX=.dylib
else ifeq ($(OS),Cygwin)
	LDPATH=PATH=$(PWD)/build/src:"$$PATH"
	PREFIX=cyg
	SUFFIX=.dll
else ifeq ($(OS),Msys)
# This is for Msys "proper"
# TODO: handle Msys/Mingw32/64
	LDPATH=PATH=$(PWD)/build/src:"$$PATH"
	PREFIX=msys-
	SUFFIX=.dll
else
	LDPATH=LD_LIBRARY_PATH=$(PWD)/build/src
	PREFIX=lib
	SUFFIX=.so
endif

# Here are
#
# 1. tests linked into a library that we run as is
# 2. tests linked into a library that we run and compare its normalized output to expected output

# TODO: the diff_tools scripts determine prefix and extension by themselves
# Would be better if those were arguments, since we do it here anyway

# These "diff tools" also normalize the output using replacements
DIFF_TOOL=../../tools/cgreen_runner_output_diff
XML_DIFF_TOOL=../../tools/cgreen_xml_output_diff
DIFF_TOOL_ARGUMENTS = $(1)_tests \
	../../tests \
	$(1)_tests.expected

.PHONY: unit
unit: build-it
	cd build ; \
	$(LDPATH) tools/cgreen-runner -c `find tests -name $(PREFIX)cgreen_c_tests$(SUFFIX)` ; \
	r=$$((r + $$?)) ; \
	$(LDPATH) tools/cgreen-runner -c `find tests -name $(PREFIX)cgreen_cpp_tests$(SUFFIX)` ; \
	r=$$((r + $$?)) ; \
	$(LDPATH) tools/cgreen-runner -c `find tools -name $(PREFIX)cgreen_runner_tests$(SUFFIX)` ; \
	r=$$((r + $$?)) ; \
	cd tests ; \
	$(LDPATH) $(XML_DIFF_TOOL) $(call DIFF_TOOL_ARGUMENTS,xml_output) ; \
	r=$$((r + $$?)) ; \
	$(LDPATH) $(DIFF_TOOL) $(call DIFF_TOOL_ARGUMENTS,assertion_messages) ; \
	r=$$((r + $$?)) ; \
	$(LDPATH) $(DIFF_TOOL) $(call DIFF_TOOL_ARGUMENTS,mock_messages) ; \
	r=$$((r + $$?)) ; \
	$(LDPATH) $(DIFF_TOOL) $(call DIFF_TOOL_ARGUMENTS,constraint_messages) ; \
	r=$$((r + $$?)) ; \
	$(LDPATH) $(DIFF_TOOL) $(call DIFF_TOOL_ARGUMENTS,custom_constraint_messages) ; \
	r=$$((r + $$?)) ; \
	$(LDPATH) $(DIFF_TOOL) $(call DIFF_TOOL_ARGUMENTS,ignore_messages) ; \
	r=$$((r + $$?)) ; \
	$(LDPATH) CGREEN_PER_TEST_TIMEOUT=1 $(DIFF_TOOL) $(call DIFF_TOOL_ARGUMENTS,failure_messages) ; \
	r=$$((r + $$?)) ; \
	exit $$r

.PHONY: doc
doc: build
	cmake -DCGREEN_WITH_HTML_DOCS:bool=TRUE -S . -B build
	cmake --build build
	cmake -DCGREEN_WITH_HTML_DOCS:bool=False -S . -B build
	echo open $(PWD)/build/doc/cgreen-guide-en.html

pdf: build
	cmake -DCGREEN_WITH_PDF_DOCS:bool=TRUE -S . -B build
	cmake --build build
	cmake -DCGREEN_WITH_PDF_DOCS:bool=FALSE -S . -B build
	echo open $(PWD)/build/doc/cgreen-guide-en.pdf

chunked: doc
	asciidoctor-chunker build/doc/cgreen-guide-en.html -o docs
	echo open $(PWD)/docs/index.html

.PHONY:valgrind
valgrind: build-it
	@echo -n "Running all tests under Valgrind "
	@> valgrind.log
	@for lib in `ls build/tests/$(PREFIX)*_tests$(SUFFIX)` ; \
	do \
		echo -n "." ; \
		LD_LIBRARY_PATH=build/src valgrind --leak-check=full build/tools/cgreen-runner $$lib >> valgrind.log 2>&1 ; \
	done
	@echo
	grep --with-filename --line-number " lost: " valgrind.log | grep -v " 0 bytes" ; \
	if [ $$? -eq 1 ] ; then echo "Nothing lost" ; fi



############# Internal
build build/Makefile:
ifeq ($(OS),Darwin)
	cmake -DCMAKE_OSX_ARCHITECTURES="arm64;x86_64" -S . -B build
	#cmake -S . -B build
else
	cmake -S . -B build
endif

.PHONY:build-it
build-it: build
	$(MAKE) -C build

.SILENT:

=== include/CMakeLists.txt ===
add_subdirectory(cgreen)

=== samples/Makefile ===
sample: sample.o
	$(CC) -o sample sample.o -lcgreen

=== src/CMakeLists.txt ===
# Generate gitrevision.h
if (GITREVISION AND GIT_EXECUTABLE)
  # Allow GITREVISION to be overridden manually / externally. This useful for vendoring.
  message(INFO, "GITREVISION manually overridden: ${GITREVISION}")
else()
  if (GITDIR AND GIT_EXECUTABLE)
    # Use the git version if Git is available and the .git directory is found.
    # NOTE: $GITDIR is determined in top-level CMakeLists.txt
    execute_process(COMMAND ${GIT_EXECUTABLE} describe --tags --always --abbrev=7 --dirty=-modified
                    OUTPUT_VARIABLE GITREVISION
                    OUTPUT_STRIP_TRAILING_WHITESPACE)
  else()
    # No version control
    # e.g. when the software is built from a source tarball
    message(WARNING "-- Unable to find git, or not a repo. Setting git revision to 'unknown'.")
    set(GITREVISION "built from unknown git commit")
  endif()
endif()

configure_file(${PROJECT_SOURCE_DIR}/gitrevision.h.in ${PROJECT_SOURCE_DIR}/gitrevision.h @ONLY)

set(CGREEN_PUBLIC_INCLUDE_DIRS
  ${PROJECT_SOURCE_DIR}/
  ${PROJECT_SOURCE_DIR}/include
  ${CMAKE_CURRENT_SOURCE_DIR}
  CACHE INTERNAL "cgreen public include directories"
)

set(CGREEN_PRIVATE_INCLUDE_DIRS
  ${PROJECT_BINARY_DIR}
)

if (MSVC)
  LIST(APPEND CGREEN_PRIVATE_INCLUDE_DIRS
    ${PROJECT_SOURCE_DIR}/../include/cgreen/internal/windows_headers
  )
endif(MSVC)

set(CGREEN_SHARED_LIBRARY
  cgreen_shared
  CACHE INTERNAL "cgreen shared library"
)

if (WIN32 AND NOT CYGWIN)
  set(CGREEN_LINK_LIBRARIES
    winmm.lib
  )
endif(WIN32 AND NOT CYGWIN)

set(cgreen_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/assertions.c
  ${CMAKE_CURRENT_SOURCE_DIR}/boxed_double.c
  ${CMAKE_CURRENT_SOURCE_DIR}/breadcrumb.c
  ${CMAKE_CURRENT_SOURCE_DIR}/cgreen_time.c
  ${CMAKE_CURRENT_SOURCE_DIR}/cgreen_value.c
  ${CMAKE_CURRENT_SOURCE_DIR}/constraint.c
  ${CMAKE_CURRENT_SOURCE_DIR}/cute_reporter.c
  ${CMAKE_CURRENT_SOURCE_DIR}/cdash_reporter.c
  ${CMAKE_CURRENT_SOURCE_DIR}/messaging.c
  ${CMAKE_CURRENT_SOURCE_DIR}/message_formatting.c
  ${CMAKE_CURRENT_SOURCE_DIR}/mocks.c
  ${CMAKE_CURRENT_SOURCE_DIR}/parameters.c
  ${CMAKE_CURRENT_SOURCE_DIR}/reporter.c
  ${CMAKE_CURRENT_SOURCE_DIR}/runner.c
  ${CMAKE_CURRENT_SOURCE_DIR}/string_comparison.c
  ${CMAKE_CURRENT_SOURCE_DIR}/suite.c
  ${CMAKE_CURRENT_SOURCE_DIR}/text_reporter.c
  ${CMAKE_CURRENT_SOURCE_DIR}/utils.c
  ${CMAKE_CURRENT_SOURCE_DIR}/vector.c
)
if (CGREEN_WITH_XML)
  LIST(APPEND cgreen_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/xml_reporter.c)
endif (CGREEN_WITH_XML)
if (CGREEN_WITH_LIBXML2)
  LIST(APPEND cgreen_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/libxml_reporter.c)
endif (CGREEN_WITH_LIBXML2)

if (MSYS)
  # Msys2 is difficult since it really is three different "OS":es, Msys native, W32 and W64
  # To get somewhere, let's use the native Msys2, which actually is Cygwin/UNIX.
  LIST(APPEND cgreen_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/posix_cgreen_pipe.c
    ${CMAKE_CURRENT_SOURCE_DIR}/posix_cgreen_time.c
    ${CMAKE_CURRENT_SOURCE_DIR}/posix_runner_platform.c
  )
elseif (UNIX OR CYGWIN)
  LIST(APPEND cgreen_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/posix_cgreen_pipe.c
    ${CMAKE_CURRENT_SOURCE_DIR}/posix_cgreen_time.c
    ${CMAKE_CURRENT_SOURCE_DIR}/posix_runner_platform.c
  )
elseif(WIN32)
 LIST(APPEND cgreen_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/win32_cgreen_pipe.c
    ${CMAKE_CURRENT_SOURCE_DIR}/win32_cgreen_time.c
    ${CMAKE_CURRENT_SOURCE_DIR}/win32_runner_platform.c
  )
else()
  message(FATAL_ERROR "Cgreen can currently only be compiled for Linux, Cygwin, MacOSX and Msys2 (native, not MingW versions). Patches are welcome!")
endif()
SET_SOURCE_FILES_PROPERTIES(${cgreen_SRCS} PROPERTIES LANGUAGE C)

set(cgreen_SRCS ${cgreen_SRCS}
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp_assertions.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp_constraint.cpp
)
SET_SOURCE_FILES_PROPERTIES(cpp_assertions.cpp cpp_constraint.cpp PROPERTIES LANGUAGE CXX )


include(DefineRelativeFilePaths)
cmake_define_relative_file_paths ("${cgreen_SRCS}")

include_directories(
  ${CGREEN_PUBLIC_INCLUDE_DIRS}
  ${CGREEN_PRIVATE_INCLUDE_DIRS}
  $<$<BOOL:${CGREEN_WITH_LIBXML2}>:${LIBXML2_INCLUDE_DIRS}>
)

### cgreen
set(CGREEN_LIBRARY_NAME cgreen)
add_library(${CGREEN_SHARED_LIBRARY} SHARED ${cgreen_SRCS} ${PROJECT_SOURCE_DIR}/gitrevision.h)

target_link_libraries(
  ${CGREEN_SHARED_LIBRARY}
  ${CGREEN_LINK_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
  ${MATH_LIB}
  ${CMAKE_CXX_IMPLICIT_LINK_LIBRARIES}
  $<$<BOOL:${CGREEN_WITH_LIBXML2}>:${LIBXML2_LIBRARIES}>
)

set_target_properties(
  ${CGREEN_SHARED_LIBRARY}
    PROPERTIES
      VERSION
        ${LIBRARY_VERSION}
      SOVERSION
        ${LIBRARY_SOVERSION}
      OUTPUT_NAME
        ${CGREEN_LIBRARY_NAME}
)

install(
  TARGETS ${CGREEN_SHARED_LIBRARY}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  DESTINATION ${CMAKE_INSTALL_BINDIR}
  COMPONENT libraries
)

if (CGREEN_WITH_STATIC_LIBRARY)

  set(CGREEN_STATIC_LIBRARY
    cgreen_static
    CACHE INTERNAL "cgreen static library"
  )

  add_library(${CGREEN_STATIC_LIBRARY} STATIC ${cgreen_SRCS})

  target_link_libraries(${CGREEN_STATIC_LIBRARY}
    ${CGREEN_LINK_LIBRARIES}
    ${MATH_LIB}
    ${CMAKE_CXX_IMPLICIT_LINK_LIBRARIES}
  )

  set_target_properties(
    ${CGREEN_STATIC_LIBRARY}
      PROPERTIES
        VERSION
          ${LIBRARY_VERSION}
        SOVERSION
          ${LIBRARY_SOVERSION}
        OUTPUT_NAME
          ${CGREEN_LIBRARY_NAME}
  )

  install(
    TARGETS ${CGREEN_STATIC_LIBRARY}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT libraries
  )
endif(CGREEN_WITH_STATIC_LIBRARY)

=== tests/CMakeLists.txt ===
set(CGREEN_TEST_INCLUDE_DIRS
  ${CGREEN_PUBLIC_INCLUDE_DIRS}
  ${CMAKE_CURRENT_BINARY_DIR}
)

check_include_file("sys/resource.h" HAVE_SYS_RESOURCE_H)
if (HAVE_SYS_RESOURCE_H)
  add_definitions(-DHAVE_SYS_RESOURCE_H)
endif(HAVE_SYS_RESOURCE_H)

if (MSVC)
  LIST(APPEND CGREEN_TEST_INCLUDE_DIRS
    ${PROJECT_SOURCE_DIR}/include/cgreen/internal/windows_headers
  )
endif(MSVC)


include_directories(${CGREEN_TEST_INCLUDE_DIRS})

# Dependency on our own library
if (CGREEN_WITH_STATIC_LIBRARY)
  set(CGREEN_LIBRARY ${CGREEN_STATIC_LIBRARY})
else ()
  set(CGREEN_LIBRARY ${CGREEN_SHARED_LIBRARY})
endif()


# C tests, library to use with runner, and a main program
# NOTE that some of these are "pure" unit tests which only
# need to work in C, since Cgreen's internal is C.
# Some others are actually testing user level functionality
# which must work both for C and C++ compiles.
# TODO: separate out those into separate dirs? Or just
# two lists of files, one which should go into C++ compilation
# too.
set(c_tests_library_SRCS
  assertion_tests.c
  breadcrumb_tests.c
  cdash_reporter_tests.c
  cgreen_value_tests.c
  constraint_tests.c
  cute_reporter_tests.c
  double_tests.c
  environment_variables_tests.c
  message_formatting_tests.c
  messaging_tests.c
  mocks_tests.c
  mocks_struct_tests.c
  parameters_tests.c
  reflective_runner_no_teardown_tests.c
  reflective_tests.c
  text_reporter_tests.c
  unit_tests.c
  vector_tests.c
)
if (CGREEN_WITH_XML)
  LIST(APPEND c_tests_library_SRCS xml_reporter_tests.c)
endif (CGREEN_WITH_XML)
if (CGREEN_WITH_LIBXML2)
  LIST(APPEND c_tests_library_SRCS libxml_reporter_tests.c)
endif (CGREEN_WITH_LIBXML2)
SET_SOURCE_FILES_PROPERTIES(${c_tests_library_SRCS} PROPERTIES LANGUAGE C)

set(CGREEN_C_TESTS_LIBRARY
  cgreen_c_tests
  CACHE INTERNAL "cgreen shared library with tests for C"
)

add_library(${CGREEN_C_TESTS_LIBRARY} SHARED ${c_tests_library_SRCS})
target_link_libraries(${CGREEN_C_TESTS_LIBRARY} ${CGREEN_LIBRARY}
  $<$<BOOL:${CGREEN_WITH_LIBXML2}>:${LIBXML2_LIBRARIES}>)
include_directories($<$<BOOL:${CGREEN_WITH_LIBXML2}>:${LIBXML2_INCLUDE_DIRS}>)
macro_add_valgrind_test(${CGREEN_C_TESTS_LIBRARY})


set(c_tests_SRCS
  all_c_tests.c
  ${c_tests_library_SRCS}
)
SET_SOURCE_FILES_PROPERTIES(${c_tests_SRCS} PROPERTIES LANGUAGE C)

set(TEST_TARGET_LIBRARIES ${CGREEN_LIBRARY}
    $<$<BOOL:${CGREEN_WITH_LIBXML2}>:${LIBXML2_LIBRARIES}>)

# unit test with main program runner
macro_add_unit_test(test_cgreen_c "${c_tests_SRCS}" "${TEST_TARGET_LIBRARIES}")
macro_add_test(NAME test_cgreen_c_run_named_test COMMAND test_cgreen_c integer_one_should_assert_true)

set(cgreen_runner_args)
if (CGREEN_WITH_XML)
  set(cgreen_runner_args -x TEST)
endif (CGREEN_WITH_XML)

# run them with cgreen-runner also
macro_add_test(NAME runner_test_cgreen_c COMMAND cgreen-runner ${cgreen_runner_args} ./${CMAKE_SHARED_LIBRARY_PREFIX}${CGREEN_C_TESTS_LIBRARY}${CMAKE_SHARED_LIBRARY_SUFFIX})


# C++ tests, library to use with runner, and a main program
# NOTE that .cpp-versions should be links to .c-versions so we avoid duplication
# so we just use the same list and add the CPP-specific tests here
foreach(c_test_file ${c_tests_library_SRCS})
  string(REGEX REPLACE "\\.c" ".cpp" cpp_test_file ${c_test_file})
  list(APPEND cpp_tests_library_SRCS ${cpp_test_file})
endforeach()

set(cpp_tests_library_SRCS
  ${cpp_tests_library_SRCS}
  cpp_assertion_tests.cpp
  )

SET_SOURCE_FILES_PROPERTIES(${cpp_tests_library_SRCS} PROPERTIES LANGUAGE CXX)

set(CGREEN_CPP_TESTS_LIBRARY
  cgreen_cpp_tests
  CACHE INTERNAL "cgreen shared library with tests for C++"
)
add_library(${CGREEN_CPP_TESTS_LIBRARY} SHARED ${cpp_tests_library_SRCS})
target_link_libraries(${CGREEN_CPP_TESTS_LIBRARY} ${CGREEN_LIBRARY} ${CMAKE_CXX_IMPLICIT_LINK_LIBRARIES})
macro_add_valgrind_test(${CGREEN_CPP_TESTS_LIBRARY})


set(cpp_tests_SRCS
  all_cpp_tests.cpp
  ${cpp_tests_library_SRCS}
)
SET_SOURCE_FILES_PROPERTIES(${cpp_tests_SRCS} PROPERTIES LANGUAGE CXX)

macro_add_unit_test(test_cgreen_cpp "${cpp_tests_SRCS}" "${TEST_TARGET_LIBRARIES}" ${CMAKE_CXX_IMPLICIT_LINK_LIBRARIES})
macro_add_test(NAME test_cgreen_cpp_run_named_test COMMAND test_cgreen_cpp different_pointers_with_same_contents_should_assert_equal)
macro_add_test(NAME runner_test_cgreen_cpp COMMAND cgreen-runner ${cgreen_runner_args} ./${CMAKE_SHARED_LIBRARY_PREFIX}${CGREEN_CPP_TESTS_LIBRARY}${CMAKE_SHARED_LIBRARY_SUFFIX})

# Temporary single CUT test library
# Maybe we should do this for all tests instead
# and then aggregate the DLL/so/dylibs instead...
# Then this might be possible to turn into a macro
# which could allow "add_runner_lib(text_reporter)"
foreach(case
    assertion
    breadcrumb
    cdash_reporter
    cgreen_value
    constraint
    cute_reporter
    double
    message_formatting
    messaging
    mocks
    mocks_struct
    parameters
    reflective
    reflective_runner_no_teardown
    text_reporter
    unit
    vector
  )
  set(${case}_tests_SRCS
      ${case}_tests.c
  )
  set(${case}_tests_library
      ${case}_tests
  )
  add_library(${${case}_tests_library} SHARED ${${case}_tests_SRCS})
  target_link_libraries(${${case}_tests_library} ${CGREEN_LIBRARY})
endforeach(case)
if (CGREEN_WITH_XML)
  add_library(xml_reporter_tests SHARED xml_reporter_tests.c)
  target_link_libraries(xml_reporter_tests ${CGREEN_LIBRARY})
endif (CGREEN_WITH_XML)
if (CGREEN_WITH_LIBXML2)
  add_library(libxml_reporter_tests SHARED libxml_reporter_tests.c)
  target_link_libraries(libxml_reporter_tests ${CGREEN_LIBRARY})
endif (CGREEN_WITH_LIBXML2)


# Libraries for a set of output comparing tests to run with runner

set(constraint_messages_library constraint_messages_tests)
set(constraint_messages_library_SRCS constraint_messages_tests.c)
add_library(${constraint_messages_library} SHARED ${constraint_messages_library_SRCS})
target_link_libraries(${constraint_messages_library} ${CGREEN_LIBRARY})

set(custom_constraint_messages_library custom_constraint_messages_tests)
set(custom_constraint_messages_library_SRCS custom_constraint_messages_tests.c)
add_library(${custom_constraint_messages_library} SHARED ${custom_constraint_messages_library_SRCS})
target_link_libraries(${custom_constraint_messages_library} ${CGREEN_LIBRARY})

set(mock_messages_library mock_messages_tests)
set(mock_messages_library_SRCS mock_messages_tests.c)
add_library(${mock_messages_library} SHARED ${mock_messages_library_SRCS})
target_link_libraries(${mock_messages_library} ${CGREEN_LIBRARY})

set(failure_messages_library failure_messages_tests)
set(failure_messages_library_SRCS failure_messages_tests.c)
add_library(${failure_messages_library} SHARED ${failure_messages_library_SRCS})
target_link_libraries(${failure_messages_library} ${CGREEN_LIBRARY})

set(assertion_messages_library assertion_messages_tests)
set(assertion_messages_library_SRCS assertion_messages_tests.c)
add_library(${assertion_messages_library} SHARED ${assertion_messages_library_SRCS})
target_link_libraries(${assertion_messages_library} ${CGREEN_LIBRARY})

set(ignore_messages_library ignore_messages_tests)
set(ignore_messages_library_SRCS ignore_messages_tests.c)
add_library(${ignore_messages_library} SHARED ${ignore_messages_library_SRCS})
target_link_libraries(${ignore_messages_library} ${CGREEN_LIBRARY})

if (CGREEN_WITH_XML)
  set(xml_output_library xml_output_tests)
  set(xml_output_library_SRCS xml_output_tests.c)
  add_library(${xml_output_library} SHARED ${xml_output_library_SRCS})
  target_link_libraries(${xml_output_library} ${CGREEN_LIBRARY})
endif (CGREEN_WITH_XML)

if (CGREEN_WITH_LIBXML2)
  set(libxml_output_library libxml_output_tests)
  set(libxml_output_library_SRCS libxml_output_tests.c)
  add_library(${libxml_output_library} SHARED ${libxml_output_library_SRCS})
  target_link_libraries(${libxml_output_library} ${CGREEN_LIBRARY})
endif (CGREEN_WITH_LIBXML2)

# TODO We should not add these if the cgreen-runner was not built e.g. no 'nm' available
macro_add_test(
    NAME constraint_messsages
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../tools/cgreen_runner_output_diff
            constraint_messages_tests       # Name
            ${CMAKE_CURRENT_SOURCE_DIR}     # Where sources are
            ${constraint_messages_library}.expected
)

macro_add_test(
    NAME custom_constraint_messsages
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../tools/cgreen_runner_output_diff
            custom_constraint_messages_tests       # Name
            ${CMAKE_CURRENT_SOURCE_DIR}     # Where sources are
            ${custom_constraint_messages_library}.expected
)

macro_add_test(
    NAME mock_messsages
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../tools/cgreen_runner_output_diff
            mock_messages_tests             # Name
            ${CMAKE_CURRENT_SOURCE_DIR}     # Where sources are
            ${mock_messages_library}.expected
)

macro_add_test(NAME failure_messages
    COMMAND env "CGREEN_PER_TEST_TIMEOUT=2" ${CMAKE_CURRENT_SOURCE_DIR}/../tools/cgreen_runner_output_diff
            failure_messages_tests          # Name
            ${CMAKE_CURRENT_SOURCE_DIR}     # Where sources are
            ${failure_messages_library}.expected
)

macro_add_test(NAME assertion_messages
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../tools/cgreen_runner_output_diff
            assertion_messages_tests        # Name
            ${CMAKE_CURRENT_SOURCE_DIR}     # Where sources are
            ${assertion_messages_library}.expected
)

macro_add_test(NAME ignore_messages
    COMMAND env "CGREEN_PER_TEST_TIMEOUT=2" ${CMAKE_CURRENT_SOURCE_DIR}/../tools/cgreen_runner_output_diff
            ignore_messages_tests           # Name
            ${CMAKE_CURRENT_SOURCE_DIR}     # Where sources are
            ${ignore_messages_library}.expected
)

if (CGREEN_WITH_XML)
  macro_add_test(NAME xml_output
      COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../tools/cgreen_xml_output_diff
              xml_output_tests                # Name
              ${CMAKE_CURRENT_SOURCE_DIR}     # Where sources are
              ${xml_output_library}.expected
  )
endif (CGREEN_WITH_XML)

if (CGREEN_WITH_LIBXML2)
  macro_add_test(NAME libxml_output
      COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../tools/cgreen_libxml_output_diff
      	libxml_output_tests
      	${CMAKE_CURRENT_SOURCE_DIR}
      	${libxml_output_library}.expected
  )
endif (CGREEN_WITH_LIBXML2)

# add verification that all public api is available as it should
add_subdirectory(api)

=== tests/Makefile ===
# This make file may serve as an example of how to easily build a lot
# of Cgreen test libraries and run them through the runner. By
# structuring it this way only affected libraries need to be rebuilt.
#
# Note that this is not official builds or tests for Cgreen. To do
# that you should go to root directory and do "make unit" or "make
# test"

CFLAGS = -Wall -fPIC -std=c99 -I../include -I.. -I../src

LIBRARY_PATH = ../build/src
ifneq ($(shell uname), Darwin)
LOAD_PATH = LD_LIBRARY_PATH=$(LIBRARY_PATH)
else
LOAD_PATH = DYLD_LIBRARY_PATH=$(LIBRARY_PATH)
endif

TEST_SOURCES = \
	assertion_tests.c \
	breadcrumb_tests.c \
	cdash_reporter_tests.c \
	cgreen_value_tests.c \
	constraint_tests.c \
	cute_reporter_tests.c \
	double_tests.c \
	environment_variables_tests.c \
	message_formatting_tests.c \
	messaging_tests.c \
	mocks_tests.c \
	parameters_tests.c \
	reflective_runner_no_teardown_tests.c \
	reflective_tests.c \
	text_reporter_tests.c \
	unit_tests.c \
	utils_tests.c \
	vector_tests.c \
	xml_reporter_tests.c \

TEST_LIBRARIES = $(patsubst %.c,lib%.so, $(TEST_SOURCES))

all: $(TEST_LIBRARIES)
	cd ..; make --no-print-directory
	$(LOAD_PATH) ../build/tools/cgreen-runner -s unittests $?

lib%_tests.so : %_tests.o ; $(CC) -shared -o $@ $^ -L$(LIBRARY_PATH) -lcgreen

=== include/cgreen/CMakeLists.txt ===
set(cgreen_HDRS
  assertions.h
  boxed_double.h
  breadcrumb.h
  cdash_reporter.h
  cgreen.h
  cgreen_value.h
  constraint.h
  constraint_syntax_helpers.h
  cpp_assertions.h
  cpp_constraint.h
  cute_reporter.h
  filename.h
  legacy.h
  mocks.h
  string_comparison.h
  reporter.h
  runner.h
  suite.h
  text_reporter.h
  unit.h
  vector.h
  xml_reporter.h
)

install(
  FILES
    ${cgreen_HDRS}
  DESTINATION
    ${CMAKE_INSTALL_INCLUDEDIR}/${APPLICATION_NAME}
  COMPONENT
    headers
)

add_subdirectory(internal)

=== include/cgreen/internal/CMakeLists.txt ===
set(cgreen_internal_HDRS
  unit_implementation.h
  mock_table.h
  mocks_internal.h
  suite_internal.h
  assertions_internal.h
  c_assertions.h
  cpp_assertions.h
  cgreen_pipe.h
  cgreen_time.h
  runner_platform.h
  function_macro.h
  stringify_token.h
)

install(
  FILES
    ${cgreen_internal_HDRS}
  DESTINATION
    ${CMAKE_INSTALL_INCLUDEDIR}/${APPLICATION_NAME}/internal
  COMPONENT
    headers
)

=== debian/changelog ===
cgreen (1.6.3-1build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 11:40:42 +0200

cgreen (1.6.3-1) unstable; urgency=medium

  * Import new upstream release (Closes: #1038145)
  * Remove patch files which are fixed by upstream
  * Update symbols

 -- Gavin Lai (賴建宇) <gavin09@gmail.com>  Tue, 03 Oct 2023 23:11:21 +0800

cgreen (1.6.2-1~exp2) experimental; urgency=medium

  * d/rules:
    - Collect debug log when dh_auto_test fails

 -- Gavin Lai (賴建宇) <gavin09@gmail.com>  Sun, 24 Sep 2023 22:14:51 +0800

cgreen (1.6.2-1~exp1) experimental; urgency=medium

  * Import new upstream release
  * d/control:
    - Bump Standards-Version to 4.6.2
    - Remove libbdf-dev from build-deps (Closes: #1010589)
    - Add libxml2-dev to build-deps
    - Add Recommends libcgreen1-dev in cgreen1
  * Update symbols
  * Add a patch to fix man page error

 -- Gavin Lai (賴建宇) <gavin09@gmail.com>  Tue, 15 Aug 2023 23:18:11 +0800

=== debian/control ===
Source: cgreen
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Gavin Lai (賴建宇) <gavin09@gmail.com>
Uploaders: SZ Lin (林上智) <szlin@debian.org>
Build-Depends: cmake, libxml2-dev, ruby-asciidoctor-pdf, debhelper-compat (= 13)
Standards-Version: 4.6.2
Homepage: https://github.com/cgreen-devs/cgreen
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/cgreen
Vcs-Git: https://salsa.debian.org/debian/cgreen.git

Package: libcgreen1-dev
Section: libdevel
Architecture: any
Depends: libcgreen1 (=${binary:Version}), ${misc:Depends}
Description: Cgreen library - development files
 A modern unit test and mocking framework for C and C++. Cgreen features
    - fast build, clean code, highly portable
    - simple auto-discovery of tests
    - fluent, expressive and readable API
    - each test runs in isolation to prevent cross-test dependencies
    - built-in mocking for C, compatible other C++ mocking libraries

Package: libcgreen1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Cgreen Library - Unit tests and mocking framework for C and C++
 A modern unit test and mocking framework for C and C++. Cgreen features
    - fast build, clean code, highly portable
    - simple auto-discovery of tests
    - fluent, expressive and readable API
    - each test runs in isolation to prevent cross-test dependencies
    - built-in mocking for C, compatible other C++ mocking librarie
 Provides the Unittest library

Package: libcgreen1-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Cgreen Library - document
 A modern unit test and mocking framework for C and C++. Cgreen features
    - fast build, clean code, highly portable
    - simple auto-discovery of tests
    - fluent, expressive and readable API
    - each test runs in isolation to prevent cross-test dependencies
    - built-in mocking for C, compatible other C++ mocking librarie
 Provides the Unittest library document

Package: cgreen1
Section: utils
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: libcgreen1-dev
Description: Cgreen Library - Library tool
 A modern unit test and mocking framework for C and C++. Cgreen features
    - fast build, clean code, highly portable
    - simple auto-discovery of tests
    - fluent, expressive and readable API
    - each test runs in isolation to prevent cross-test dependencies
    - built-in mocking for C, compatible other C++ mocking librarie
 Provides the Unittest test tool

=== debian/tests/control ===
Tests: testsuite
Restrictions: allow-stderr, superficial
Depends: @
